#include "stdio.h"
#include "stdlib.h"
#include "queue.h"
#include "string.h"

#define NUMLINES 10
#define BUFSIZE 0x1000

int tail (FILE *fin, size_t num_lines) {
  queue *q = new_queue();
  size_t lines = 0;
  char buffer[BUFSIZE];
  while (fgets (buffer, BUFSIZE, fin)) {
    size_t nbytes = sizeof(char) * (strlen (buffer) + 1);
    char * line = malloc (nbytes);
    strncpy (line, buffer, nbytes);
    enqueue (q, line);
    if (lines < num_lines) {
      lines++;
    } else {
      line = dequeue (q);
      if (line != NULL) {
	free (line);
      }
    }
  }
  // it remains to dump the queue to stdout
  while (!is_empty (q)) {
    char *line = dequeue (q);
    fputs (line, stdout);
    free (line);
  }
  free_queue (q);
  return 0;
}

int main (int argc, char * argv[]) {
  return tail (stdin, NUMLINES);
}
